/*	
    Leggere da tastiera un array di interi senza conoscerne la lunghezza. 
    La sequenza di interi in input è terminata dal primo elemento che 
    non è un intero
*/

#include <stdlib.h>
#include <stdio.h>

int main() {

  int elementi = 0; // numero interi letti 
  int allocati = 1; // spazio allocato 
  int *tmp, *a; // array con gli interi
  int i;

  a = malloc( sizeof(int)* allocati );
  if( a == NULL ) return 1;

  while( scanf("%d", a+elementi) == 1 ) 
    if( ++elementi == allocati ) { // spazio esaurito alloca piu spazio
	  /* si può rimpiazzare l'intero corpo dell'if con 
	    n*=2; a = realloc(a, n * sizeof(int));
	  */
	  allocati *= 2;
	  tmp = malloc( sizeof(int) * allocati );
	  if( tmp == NULL ) return 1;	
	  
	  /* copia gli elementi da a in tmp */
	  for ( i = 0; i < elementi; i++ ) 
	      tmp[i] = a[i];
	  free(a); // libera la memoria allocata precedentemente
	  a = tmp;
      }

  /* controlla se è allocato più spazio del necessario, in tal caso alloca lo spazio necessario e copia */
  if( elementi != allocati ) // la porzione nell'if (nuova allocazione + copia) può essere scritta usando la sola realloc (consultare il manuale) 
     a = realloc(a, elementi * sizeof(int));

  for ( i = 0; i < elementi; i++ ) /* stampa gli elementi letti */
	printf("%d\n", a[i]);

  return 0;
}