/* 
  Scrivere un programma che legga da input un array di interi ordinati in ordine non decrescente. 
  Il primo valore non intero letto da input termina la lettura da input. 
  Controllare che l'array sia effettivamente ordinato in ordine non decrescente, 
  scrivere in output "s\n" in tale caso o "n\n" altrimenti. 
  Se l'array è ordinato restituire anche il numero di elementi distinti 
  in esso contenuti. 
*/

#include <stdlib.h>
#include <stdio.h>

int main() {

  int ordinato = 1 , distinti;
  int elementi = 0; // numero interi letti 
  int allocati = 1; // spazio allocato 
  int *tmp, *a; // array con gli interi
  int i;

  a = malloc( sizeof(int)* allocati );
  if( a == NULL ) return 1;

  while( scanf("%d", a+elementi) == 1 )
    if( ++elementi == allocati ) { // spazio esaurito alloca piu spazio
	  /* si può rimpiazzare l'intero corpo dell'if con 
	    n*=2; a = realloc(a, n * sizeof(int));
	  */
	  allocati *= 2;
	  tmp = malloc( sizeof(int) * allocati );
	  if( tmp == NULL ) return 1;	
	  
	  /* copia gli elementi da a in tmp */
	  for ( i = 0; i < elementi; i++ ) 
	      tmp[i] = a[i];
	  free(a); // libera la memoria allocata precedentemente
	  a = tmp;
      }

  /* controlla se è allocato più spazio del necessario, in tal caso alloca lo spazio necessario e copia */
  if( elementi != allocati ) // la porzione nell'if (nuova allocazione + copia) può essere scritta usando la sola realloc (consultare il manuale) 
     a = realloc(a, elementi * sizeof(int));

  for ( i = 0; i < nc-1; i++ ) /* controlla se l'array è ordinato o meno */
	if( a[i] > a[i+1] ) { 
	      ordinato = 0;
	      break;
  }

  if (!ordinato) { 
      printf("n\n");
      return 0;
  }
  
  distinti = 1;
  for ( i = 1; i < nc; i++ ) 
      if( a[i-1] != a[i] ) distinti++; 

  printf("s %d\n", distinti);

  return 0;
}